//
//  NSPrefPaneUtils.h
//  PrefPaneUtils
//
//  Created by Dave Jewell on 07/12/2008.
//  Copyright 2008 Cocoa Secrets. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface NSPrefPaneUtils : NSObject
{
}

+ (NSPrefPaneUtils *) sharedPrefPaneUtils;
+ (BOOL) _needFN;;
+ (BOOL) isMacOSXServer;
+ (BOOL) hasBattery;
+ (BOOL) isTimeMachineEnabled;
+ (void) enableControls: (BOOL) enable inView: (NSView *) view deep: (BOOL) deep;
+ (NSString *) centerTruncateString: (NSString *) string toFit: (NSInteger) width;

// Key representation stuff
+ (NSString *) stringForSymbolicKey: (NSUInteger) symbolicKey;
+ (NSString *) stringForSymbolicKey: (NSUInteger) symbolicKey respectFN: (BOOL) respectFN;
+ (NSString *) _labelForVirtualKey: (NSUInteger) virtKey;
+ (NSString *) _stringForVirtualKey: (NSUInteger) virtKey modifiers: (NSUInteger) modifiers;
+ (NSString *) stringForVirtualKey: (NSUInteger) virtKey modifiers: (NSUInteger) modifiers;
+ (NSString *) humanStringForVirtualKey: (NSUInteger) virtKey modifiers: (NSUInteger) modifiers;
+ (NSString *) stringForModifiers: (NSUInteger) modifiers;
+ (NSString *) humanStringForModifiers: (NSUInteger) modifiers;
+ (BOOL) isFunctionKey: (NSUInteger) virtKey;
+ (NSString *) _isFunctionCharCodeKey: (NSString *) charCode;
+ (NSString *) _stringForCharacterCode: (NSString *) charCode;	
+ (NSString *) humanStringForCharacterCode: (NSString *) charCode modifiers: (NSUInteger) modifiers;
+ (NSString *) stringForCharacterCode: (NSString *) charCode modifiers: (NSUInteger) modifiers;

- (void) dealloc;
- (void) startKeyboardMonitor;
- (void) stopKeyboardMonitor;

@end
