//
//  NXApplication.m
//  SystemKeys
//
//  Created by Dave Jewell on 28/01/2009.
//  Copyright 2009 Cocoa Secrets. All rights reserved.
//

#import "NXApplication.h"
#import "SymbolicKeys.h"

// We only use NSPrefPaneUtils to dump the current state of play in awakeFromNib.  
// It's not needed for symbolic key support.  
// Same goes for linking against PreferencePanes.framework

#import "NSPrefPaneUtils.h"					

@implementation NXApplication

- (void) sendEvent: (NSEvent *) event
{
	if ([event type] == NSSystemDefined &&
			[event subtype] == 6 && 
			[event data1] == 999) 
	{
			NSLog (@"Yo!!!");
			return;
	}
	
	[super sendEvent: event];
}

/*
 Assorted comments:
 To idiot-proof your code, it would be a good idea to check that the currently running version of the OS supports the specified symbolic key.
 Also, a well-written application should restore hot-key status quo when exiting....probably ;-)  
 */

- (void) awakeFromNib 
{
	// Dump the current state of play, so we can see current assignments and enable/disable states...
	NSInteger idx;
	for (idx = 1; idx <= 149; idx++)
	{
		BOOL enabled = CGSIsSymbolicHotKeyEnabled (idx);
		NSLog (@"Hotkey %d is %@ (%@)", idx, enabled ? @"enabled" : @"disabled", [NSPrefPaneUtils stringForSymbolicKey: idx]);
	}
	
	// Ensure code we want is enabled...
	CGSSetSymbolicHotKeyEnabled (144, YES);
	
	// ...And give it a data code of 999
	CGSSetSymbolicHotKey (CGSMainConnectionID(), 999, 144);	
	
	// If you want to change the keycode and modifiers......
	// CGSSetSymbolicHotKeyValue (144, 0xffff, --your keycode--, --your modifier mask--) != 0);
}

@end
